package com.wanji.indicators.mapper;

import com.wanji.indicators.entity.BaseLaneInfo;
import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

public interface BaseLaneInfoMapper extends BaseMapper<BaseLaneInfo>{
	
	 /**
	  *  查询表t_base_lane_info所有信息
	  */
	 List<BaseLaneInfo> findAllBaseLaneInfo();
	  
	 /**
	  *  根据主键id查询表t_base_lane_info信息
	  *  @param id
	  */
	 BaseLaneInfo findBaseLaneInfoByid(@Param("id") String id);

	/**
	*  根据条件查询表t_base_lane_info信息
	*  @param baseLaneInfo
	*/
	List<BaseLaneInfo> findBaseLaneInfoByCondition(BaseLaneInfo baseLaneInfo);

	 /**
	  *  根据主键id查询表t_base_lane_info信息
	  *  @param id
	  */
	 Integer deleteBaseLaneInfoByid(@Param("id") String id);
	
	 /**
	  *  根据主键id更新表t_base_lane_info信息
	  *  @param baseLaneInfo
	  */
	 Integer updateBaseLaneInfoByid(BaseLaneInfo baseLaneInfo);
	
	 /**
	  *  新增表t_base_lane_info信息
	  *  @param baseLaneInfo
	  */
	 Integer addBaseLaneInfo(BaseLaneInfo baseLaneInfo);
	
}

